Index: /library/doc/tutorial/000install.dox
===================================================================
--- /library/doc/tutorial/000install.dox (revision 782)
+++ /library/doc/tutorial/000install.dox (revision 782)
@@ -0,0 +1,104 @@
+/*!
+\page install BDM Use - Installation
+
+BDM is written as a multiplatform library, which was tested on Linux, Windows and Mac OSX.
+However, installation on each platform is specific.
+
+BDM comes in two basic versions:
+\li \b binary   with precompiled executables and matlab mex files that can be configured by external text files
+\li \b source \b code  that can be compiled into any required form. 
+
+\section in_bin Binaries for BDMtoolbox
+Binaries for the matlab BDMtoolbox are available only for windows (win32) platform, compiled against matlab 7.1 for compatibility.
+
+Installation:
+\li svn checkout http://mys.utia.cas.cz:1800/svn/mixpp/applications/bdmtoolbox/ into your local directory of your choice (this will be denoted \<toolbox_dir\>)
+\li open matlab and type: \>\> addpath \<toolbox_dir\>/mex; addpath \<toolbox_dir\>/mexw32
+\li the toolbox is ready to be used, test it e.g. by: \>\> cd tutorial/userguide; pdfds_example
+\li if no error is given, the toolbox is installed correctly
+\li proceed to http://mys.utia.cas.cz:1800/trac/bdm/doxygen/pages.html to learn how to use it
+
+\section src Source code
+
+is available from svn repository:
+http://mys.utia.cas.cz:1800/svn/mixpp using guest/guest as login/password.
+
+For download use an appropriate SVN client http://subversion.tigris.org/links.html#clients
+
+Download the source files to any directory of your choise, this directoory will be refered to as \<bdm_dir\>.
+
+\subsection pre Prerequisities
+
+You need to have the following tools available on your system:
+\li working C++ compiler, e.g. gcc on Linux, or Visual Studio on windows
+\li CMake, a cross-platform build system, http://www.cmake.org
+\li ITPP library, http://itpp.sourceforge.net/ which is a part of all major linux distributions, for its installation on Windows, see Section Windows.
+ 
+\section lin Linux
+
+All prerequisities are available as binary packages for most distribution. E.g. for debian-based distributions, use
+\code
+apt-get install g++ cmake libitpp-dev 
+\endcode
+
+\note If you want to use mex files, you need to build IT++ from sources using the classi configure;make;make install. 
+The necessary flags for configure for mex compilation are in file linux/configure_itpp.
+
+Compile the BDM library and its applications using 
+\code
+$ cd <bdm_dir>/library/
+$ cmake .
+$ make
+\endcode
+
+
+\section win Windows
+
+The following approach was tested on the Microsoft Visual Studio 9. 
+
+Make sure you have cmake installed.
+
+Expert users are advised to download and compile their ITPP version following a guide on : 
+http://itpp.sourceforge.net/current/installation.html
+
+For convenience of the beginners, DLLS of the ACML and lib+include files for ITPP and ACML are
+provided at: http://staff.utia.cas.cz/smidl/Public/mixpp_win32lib.zip
+If you want to use them copy the content of the zip file to \<bdm_dir\>/library/system/win32/ directory and
+make sure to set your PATH environment variable:
+\code
+ Path = %PATH%; <bdm_dir>\library\system\win32\dll
+\endcode
+
+Be sure to set system variable globally, i.e., through the dialog box "System Properties", 
+tab "Advanced" and button "Environment Variables". Otherwise you will not be able to run 
+any programs.
+
+
+Compilation of BDM:
+
+ * When everything is set-up, make a copy of library\system\win32\run_cmake.bat, edit it 
+  to reflect your environment (i.e. change paths to cmake and your C++ target environment) 
+  and run it.
+
+ * It should generate build files for your compiler in the main BDM 
+  directory
+
+For more comfortable work with Subversion, we recommend to install also AnkhSVN - 
+a Visual Studio plug-in that perfectly integrates Subversion into the GUI, see http://ankhsvn.open.collab.net/
+
+
+\section mac Mac OS X
+
+All prerequisities for Mac OS X are avaliable except for ITPP, make sure you have them installed.
+
+However, its compilation is straightforward. 
+
+ 1. Download the latest stable release from http://itpp.sourceforge.net
+ 2. Compile it using script system/mac/itpp_compile.sh
+
+The default cmake configuration is looking for itpp in directory mac/itpp, make sure you have symlinks to this directory.
+
+If itpp compilation is successfull, you can run Cmake. Fill in the paths to your BDM directory, run Configure followed by Create.
+Configuration files for your favourite build environment should be created in the BDM directory.
+
+*/
Index: /brary/doc/tutorial/00install.dox
===================================================================
--- /library/doc/tutorial/00install.dox (revision 778)
+++  (revision )
@@ -1,104 +1,0 @@
-/*!
-\page install BDM Use - Installation
-
-BDM is written as a multiplatform library, which was tested on Linux, Windows and Mac OSX.
-However, installation on each platform is specific.
-
-BDM comes in two basic versions:
-\li \b binary   with precompiled executables and matlab mex files that can be configured by external text files
-\li \b source \b code  that can be compiled into any required form. 
-
-\section in_bin Binaries for BDMtoolbox
-Binaries for the matlab BDMtoolbox are available only for windows (win32) platform, compiled against matlab 7.1 for compatibility.
-
-Installation:
-\li svn checkout http://mys.utia.cas.cz:1800/svn/mixpp/applications/bdmtoolbox/ into your local directory of your choice (this will be denoted \<toolbox_dir\>)
-\li open matlab and type: \>\> addpath \<toolbox_dir\>/mex; addpath \<toolbox_dir\>/mexw32
-\li the toolbox is ready to be used, test it e.g. by: \>\> cd tutorial/userguide; pdfds_example
-\li if no error is given, the toolbox is installed correctly
-\li proceed to http://mys.utia.cas.cz:1800/trac/bdm/doxygen/pages.html to learn how to use it
-
-\section src Source code
-
-is available from svn repository:
-http://mys.utia.cas.cz:1800/svn/mixpp using guest/guest as login/password.
-
-For download use an appropriate SVN client http://subversion.tigris.org/links.html#clients
-
-Download the source files to any directory of your choise, this directoory will be refered to as \<bdm_dir\>.
-
-\subsection pre Prerequisities
-
-You need to have the following tools available on your system:
-\li working C++ compiler, e.g. gcc on Linux, or Visual Studio on windows
-\li CMake, a cross-platform build system, http://www.cmake.org
-\li ITPP library, http://itpp.sourceforge.net/ which is a part of all major linux distributions, for its installation on Windows, see Section Windows.
- 
-\section lin Linux
-
-All prerequisities are available as binary packages for most distribution. E.g. for debian-based distributions, use
-\code
-apt-get install g++ cmake libitpp-dev 
-\endcode
-
-\note If you want to use mex files, you need to build IT++ from sources using the classi configure;make;make install. 
-The necessary flags for configure for mex compilation are in file linux/configure_itpp.
-
-Compile the BDM library and its applications using 
-\code
-$ cd <bdm_dir>/library/
-$ cmake .
-$ make
-\endcode
-
-
-\section win Windows
-
-The following approach was tested on the Microsoft Visual Studio 9. 
-
-Make sure you have cmake installed.
-
-Expert users are advised to download and compile their ITPP version following a guide on : 
-http://itpp.sourceforge.net/current/installation.html
-
-For convenience of the beginners, DLLS of the ACML and lib+include files for ITPP and ACML are
-provided at: http://staff.utia.cas.cz/smidl/Public/mixpp_win32lib.zip
-If you want to use them copy the content of the zip file to \<bdm_dir\>/library/system/win32/ directory and
-make sure to set your PATH environment variable:
-\code
- Path = %PATH%; <bdm_dir>\library\system\win32\dll
-\endcode
-
-Be sure to set system variable globally, i.e., through the dialog box "System Properties", 
-tab "Advanced" and button "Environment Variables". Otherwise you will not be able to run 
-any programs.
-
-
-Compilation of BDM:
-
- * When everything is set-up, make a copy of library\system\win32\run_cmake.bat, edit it 
-  to reflect your environment (i.e. change paths to cmake and your C++ target environment) 
-  and run it.
-
- * It should generate build files for your compiler in the main BDM 
-  directory
-
-For more comfortable work with Subversion, we recommend to install also AnkhSVN - 
-a Visual Studio plug-in that perfectly integrates Subversion into the GUI, see http://ankhsvn.open.collab.net/
-
-
-\section mac Mac OS X
-
-All prerequisities for Mac OS X are avaliable except for ITPP, make sure you have them installed.
-
-However, its compilation is straightforward. 
-
- 1. Download the latest stable release from http://itpp.sourceforge.net
- 2. Compile it using script system/mac/itpp_compile.sh
-
-The default cmake configuration is looking for itpp in directory mac/itpp, make sure you have symlinks to this directory.
-
-If itpp compilation is successfull, you can run Cmake. Fill in the paths to your BDM directory, run Configure followed by Create.
-Configuration files for your favourite build environment should be created in the BDM directory.
-
-*/